#!/usr/bin/env python3
	####
#This script monitors StarWind event log and triggers rescan
#When service finished full/fast sync of devices
####

import pyinotify
import re
import os
import subprocess
import threading

wm = pyinotify.WatchManager()
mask = pyinotify.IN_MODIFY


class EventHandler (pyinotify.ProcessEvent):

    def __init__(self, file_path, *args, **kwargs):
        super(EventHandler, self).__init__(*args, **kwargs)
        self.file_path = file_path
        self._last_position = 0
        logpats = r'I2G\(JV\)'
        self._logpat = re.compile(logpats)

    def process_IN_MODIFY(self, event):
        if self._last_position > os.path.getsize(self.file_path):
            self._last_position = 0
        with open(self.file_path) as f:
            f.seek(self._last_position)
            loglines = f.readlines()
            self._last_position = f.tell()
            groups = (self._logpat.search(line.strip()) for line in loglines)
            if any('ID_773' in st for st in loglines) or any('ID_769' in st for st in loglines):
                 dev_null = open('/dev/null', 'w')
                 #print(loglines)
                 subprocess.call('/opt/starwind/starwind-virtual-san/drive_c/starwind/rescan_px.sh', stdin=subprocess.PIPE, stdout=dev_null.fileno(), stderr=subprocess.STDOUT)
                 #print('rescan script was trigerred')
                 


handler = EventHandler('events/StarWindVSA-Events.log')
notifier = pyinotify.Notifier(wm, handler)

wm.add_watch(handler.file_path, mask)        
notifier.loop()
